#!/usr/local/bin/python2.6
#
# wblg-new.py -- an utility to add an entry to WadcomBlog source tree
#
# Copyright (c) 2007-2008 Vlad Skvortsov, vss@73rus.com
#
# $Id: wblg-new.py 1628 2008-05-09 21:39:06Z vss $
# $HeadURL: https://svn.xiolabs.com/vss/wadcomblog/tags/0.3/src/wblg-new.py $
#
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions are met:
#
#  * Redistributions of source code must retain the above copyright notice, 
# this list of conditions and the following disclaimer.
#  * Redistributions in binary form must reproduce the above copyright notice, 
# this list of conditions and the following disclaimer in the documentation 
# and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.
#


import os
import sys
import time
import re

if len(sys.argv) < 2:
    sys.stderr.write(
"""
Usage:
    %s <title> [tag [tag ..]]

""" % sys.argv[0]
    );

    sys.exit(1)

title = sys.argv[1]
tags = map(lambda x: x.lower(), sys.argv[3:])

title_dir = \
    re.sub("^-+", "",
        re.sub("-+$", "",
            re.sub("[ ()]+", "-", title.lower())
        )
    )

if os.path.exists(title_dir):
    sys.stderr.write("'%s' already exists\n" % title_dir)
    sys.exit(1)

os.mkdir(title_dir)

entry_name = os.path.join(title_dir, "index.html")

open(entry_name, "w").write(
"""Title: %s
Timestamp: %s
Tags: %s

<p>
Abstract

<!-- WADCOMBLOG: header-end -->

<p>
Main story

""" % (
        title,
        time.strftime("%Y%m%d%H%M"),
        " ".join(tags)
    )
);

if os.system("svn add %s" % title_dir):
    sys.stderr.write("Can't add %s/ to SVN\n" % title_dir)
    sys.exit(1)
